# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from . import utilities, tables

class VappEntity(pulumi.CustomResource):
    container_id: pulumi.Output[str]
    """
    [Managed object ID|docs-about-morefs] of the vApp
    container the entity is a member of.
    """
    custom_attributes: pulumi.Output[dict]
    start_action: pulumi.Output[str]
    """
    How to start the entity. Valid settings are none
    or powerOn. If set to none, then the entity does not participate in auto-start.
    Default: powerOn
    """
    start_delay: pulumi.Output[float]
    """
    Delay in seconds before continuing with the next
    entity in the order of entities to be started. Default: 120
    """
    start_order: pulumi.Output[float]
    """
    Order to start and stop target in vApp. Default: 1
    """
    stop_action: pulumi.Output[str]
    """
    Defines the stop action for the entity. Can be set
    to none, powerOff, guestShutdown, or suspend. If set to none, then the entity
    does not participate in auto-stop. Default: powerOff
    """
    stop_delay: pulumi.Output[float]
    """
    Delay in seconds before continuing with the next
    entity in the order sequence. This is only used if the stopAction is
    guestShutdown. Default: 120
    """
    tags: pulumi.Output[list]
    target_id: pulumi.Output[str]
    """
    [Managed object ID|docs-about-morefs] of the entity
    to power on or power off. This can be a virtual machine or a vApp.
    """
    wait_for_guest: pulumi.Output[bool]
    """
    Determines if the VM should be marked as being
    started when VMware Tools are ready instead of waiting for `start_delay`. This
    property has no effect for vApps. Default: false
    """
    def __init__(__self__, resource_name, opts=None, container_id=None, custom_attributes=None, start_action=None, start_delay=None, start_order=None, stop_action=None, stop_delay=None, tags=None, target_id=None, wait_for_guest=None, __name__=None, __opts__=None):
        """
        The `vsphere_vapp_entity` resource can be used to describe the behavior of an
        entity (virtual machine or sub-vApp container) in a vApp container.
        
        For more information on vSphere vApps, see [this
        page][ref-vsphere-vapp].
        
        [ref-vsphere-vapp]: https://docs.vmware.com/en/VMware-vSphere/6.5/com.vmware.vsphere.vm_admin.doc/GUID-2A95EBB8-1779-40FA-B4FB-4D0845750879.html
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] container_id: [Managed object ID|docs-about-morefs] of the vApp
               container the entity is a member of.
        :param pulumi.Input[str] start_action: How to start the entity. Valid settings are none
               or powerOn. If set to none, then the entity does not participate in auto-start.
               Default: powerOn
        :param pulumi.Input[float] start_delay: Delay in seconds before continuing with the next
               entity in the order of entities to be started. Default: 120
        :param pulumi.Input[float] start_order: Order to start and stop target in vApp. Default: 1
        :param pulumi.Input[str] stop_action: Defines the stop action for the entity. Can be set
               to none, powerOff, guestShutdown, or suspend. If set to none, then the entity
               does not participate in auto-stop. Default: powerOff
        :param pulumi.Input[float] stop_delay: Delay in seconds before continuing with the next
               entity in the order sequence. This is only used if the stopAction is
               guestShutdown. Default: 120
        :param pulumi.Input[str] target_id: [Managed object ID|docs-about-morefs] of the entity
               to power on or power off. This can be a virtual machine or a vApp.
        :param pulumi.Input[bool] wait_for_guest: Determines if the VM should be marked as being
               started when VMware Tools are ready instead of waiting for `start_delay`. This
               property has no effect for vApps. Default: false
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if not resource_name:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(resource_name, str):
            raise TypeError('Expected resource name to be a string')
        if opts and not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if container_id is None:
            raise TypeError("Missing required property 'container_id'")
        __props__['container_id'] = container_id

        __props__['custom_attributes'] = custom_attributes

        __props__['start_action'] = start_action

        __props__['start_delay'] = start_delay

        __props__['start_order'] = start_order

        __props__['stop_action'] = stop_action

        __props__['stop_delay'] = stop_delay

        __props__['tags'] = tags

        if target_id is None:
            raise TypeError("Missing required property 'target_id'")
        __props__['target_id'] = target_id

        __props__['wait_for_guest'] = wait_for_guest

        super(VappEntity, __self__).__init__(
            'vsphere:index/vappEntity:VappEntity',
            resource_name,
            __props__,
            opts)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

